import java.nio.channels.spi.SelectorProvider;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.net.InetSocketAddress;
import java.io.IOException;

public class SelectorProviderExample {

    public static void main (String [] args)
            throws IOException {

        ServerSocketChannel serverChannel = 
		        SelectorProvider.provider().openServerSocketChannel();
        InetSocketAddress hostAddress = new InetSocketAddress("localhost", 3888);
        serverChannel.bind(hostAddress);

        System.out.println("Server socket channel bound to port: " + hostAddress.getPort());
        System.out.println("Waiting for a client to connect... ");

        // The socket channel for the new connection
        SocketChannel socketChannel = serverChannel.accept(); 

        // Process further; send or receive messages to-fro client here ...
        // The code to process is not included here

        socketChannel.close();
        serverChannel.close();
    }
}